
package de.ivu.elect.business.kandidatur.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.kandidatur.entity.Listenkandidatur;

@RequestScoped
@Named(ListenkandidaturConversationSelect.COMPONENT_NAME)
public class ListenkandidaturConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "listenkandidaturConversationSelect";

  @Inject
  protected transient ListenkandidaturExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(ListenkandidaturConversationStore.class)
  protected transient ListenkandidaturConversationStore conversationStore;

  public ListenkandidaturConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Listenkandidatur getEntity() {
    return getEntityInternal();
  }

  private Listenkandidatur getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Listenkandidatur entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Listenkandidatur entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.person.entity.PersonendatenPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.person.entity.PersonendatenPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Listenkandidatur attach(Listenkandidatur entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Listenkandidatur attach( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
